# all files / ol/interaction/ translateinteraction.js

92.86% Statements 65/70
76.47% Branches 26/34
100% Functions 10/10
92.86% Lines 65/70

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    2571×
    1×

    1×
    1×
    1×
    1×

    1×

    1×

    3×

    3×

    3×

    1×

    1×
    3×

    3×

    3×

    3×

    3×

    1×

    1×
    2×
    2×
    1×
    1×
    1×

    1×

    1×

    1×
    1×
    1×
    1×
    1×

    1×

    1×
    1×
    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×

    1×
    1×

    1×

    4×
    4×

    3×

    4×
    3×

    3×

    2×

    3×

    3×

    3×

    1×

    1×

    1×
    2×

    2×

    2×

    2×

    1×

    2×

     goog.provide('ol.interaction.Translate');
    goog.provide('ol.interaction.TranslateEvent');

    goog.require('goog.events');
    goog.require('goog.events.Event');
    goog.require('ol.array');
    goog.require('ol.interaction.Pointer');

    /**
     * @enum {string}
     */
    ol.interaction.TranslateEventType = {
      /**
       * Triggered upon feature translation start.
       * @event ol.interaction.TranslateEvent#translatestart
       * @api
       */
      TRANSLATESTART: 'translatestart',
      /**
       * Triggered upon feature translation.
       * @event ol.interaction.TranslateEvent#translating
       * @api
       */
      TRANSLATING: 'translating',
      /**
       * Triggered upon feature translation end.
       * @event ol.interaction.TranslateEvent#translateend
       * @api
       */
      TRANSLATEEND: 'translateend'
    };

    /**
     * @classdesc
     * Events emitted by {@link ol.interaction.Translate} instances are instances of
     * this type.
     *
     * @constructor
     * @extends {goog.events.Event}
     * @implements {oli.interaction.TranslateEvent}
     * @param {ol.interaction.TranslateEventType} type Type.
     * @param {ol.Collection.<ol.Feature>} features The features translated.
     * @param {ol.Coordinate} coordinate The event coordinate.
     */
    ol.interaction.TranslateEvent = function(type, features, coordinate) {

      goog.base(this, type);

      /**
       * The features being translated.
       * @type {ol.Collection.<ol.Feature>}
       * @api
       */
      this.features = features;

      /**
       * The coordinate of the drag event.
       * @const
       * @type {ol.Coordinate}
       * @api
       */
      this.coordinate = coordinate;
    };
    goog.inherits(ol.interaction.TranslateEvent, goog.events.Event);

    /**
     * @classdesc
     * Interaction for translating (moving) features.
     *
     * @constructor
     * @extends {ol.interaction.Pointer}
     * @fires ol.interaction.TranslateEvent
     * @param {olx.interaction.TranslateOptions} options Options.
     * @api
     */
    ol.interaction.Translate = function(options) {
      goog.base(this, {
        handleDownEvent: ol.interaction.Translate.handleDownEvent_,
        handleDragEvent: ol.interaction.Translate.handleDragEvent_,
        handleMoveEvent: ol.interaction.Translate.handleMoveEvent_,
        handleUpEvent: ol.interaction.Translate.handleUpEvent_
      });

      /**
       * @type {string|undefined}
       * @private
       */
      this.previousCursor_ = undefined;

      /**
       * The last position we translated to.
       * @type {ol.Coordinate}
       * @private
       */
      this.lastCoordinate_ = null;

      /**
       * @type {ol.Collection.<ol.Feature>}
       * @private
       */
      this.features_ = options.features !== undefined ? options.features : null;

      /**
       * @type {ol.Feature}
       * @private
       */
      this.lastFeature_ = null;
    };
    goog.inherits(ol.interaction.Translate, ol.interaction.Pointer);

    /**
     * @param {ol.MapBrowserPointerEvent} event Event.
     * @return {boolean} Start drag sequence?
     * @this {ol.interaction.Translate}
     * @private
     */
    ol.interaction.Translate.handleDownEvent_ = function(event) {
      this.lastFeature_ = this.featuresAtPixel_(event.pixel, event.map);
      if (!this.lastCoordinate_ && this.lastFeature_) {
        this.lastCoordinate_ = event.coordinate;
        ol.interaction.Translate.handleMoveEvent_.call(this, event);
        this.dispatchEvent(
            new ol.interaction.TranslateEvent(
                ol.interaction.TranslateEventType.TRANSLATESTART, this.features_,
                event.coordinate));
        return true;
      }
      return false;
    };

    /**
     * @param {ol.MapBrowserPointerEvent} event Event.
     * @return {boolean} Stop drag sequence?
     * @this {ol.interaction.Translate}
     * @private
     */
    ol.interaction.Translate.handleUpEvent_ = function(event) {
      Eif (this.lastCoordinate_) {
        this.lastCoordinate_ = null;
        ol.interaction.Translate.handleMoveEvent_.call(this, event);
        this.dispatchEvent(
            new ol.interaction.TranslateEvent(
                ol.interaction.TranslateEventType.TRANSLATEEND, this.features_,
                event.coordinate));
        return true;
      }
      return false;
    };

    /**
     * @param {ol.MapBrowserPointerEvent} event Event.
     * @this {ol.interaction.Translate}
     * @private
     */
    ol.interaction.Translate.handleDragEvent_ = function(event) {
      Eif (this.lastCoordinate_) {
        var newCoordinate = event.coordinate;
        var deltaX = newCoordinate[0] - this.lastCoordinate_[0];
        var deltaY = newCoordinate[1] - this.lastCoordinate_[1];

        Eif (this.features_) {
          this.features_.forEach(function(feature) {
            var geom = feature.getGeometry();
            geom.translate(deltaX, deltaY);
            feature.setGeometry(geom);
          });
        } else if (this.lastFeature_) {
          var geom = this.lastFeature_.getGeometry();
          geom.translate(deltaX, deltaY);
          this.lastFeature_.setGeometry(geom);
        }

        this.lastCoordinate_ = newCoordinate;
        this.dispatchEvent(
            new ol.interaction.TranslateEvent(
                ol.interaction.TranslateEventType.TRANSLATING, this.features_,
                newCoordinate));
      }
    };

    /**
     * @param {ol.MapBrowserEvent} event Event.
     * @this {ol.interaction.Translate}
     * @private
     */
    ol.interaction.Translate.handleMoveEvent_ = function(event)
        {
      var elem = event.map.getTargetElement();
      var intersectingFeature = event.map.forEachFeatureAtPixel(event.pixel,
          function(feature) {
            return feature;
          });

      if (intersectingFeature) {
        var isSelected = false;

        if (this.features_ &&
            ol.array.includes(this.features_.getArray(), intersectingFeature)) {
          isSelected = true;
        }

        this.previousCursor_ = elem.style.cursor;

        // WebKit browsers don't support the grab icons without a prefix
        elem.style.cursor = this.lastCoordinate_ ?
            '-webkit-grabbing' : (isSelected ? '-webkit-grab' : 'pointer');

        // Thankfully, attempting to set the standard ones will silently fail,
        // keeping the prefixed icons
        elem.style.cursor = !this.lastCoordinate_ ?
            'grabbing' : (isSelected ? 'grab' : 'pointer');

      } else {
        elem.style.cursor = this.previousCursor_ !== undefined ?
            this.previousCursor_ : '';
        this.previousCursor_ = undefined;
      }
    };

    /**
     * Tests to see if the given coordinates intersects any of our selected
     * features.
     * @param {ol.Pixel} pixel Pixel coordinate to test for intersection.
     * @param {ol.Map} map Map to test the intersection on.
     * @return {ol.Feature} Returns the feature found at the specified pixel
     * coordinates.
     * @private
     */
    ol.interaction.Translate.prototype.featuresAtPixel_ = function(pixel, map) {
      var found = null;

      var intersectingFeature = map.forEachFeatureAtPixel(pixel,
          function(feature) {
            return feature;
          });

      if (this.features_ &&
          ol.array.includes(this.features_.getArray(), intersectingFeature)) {
        found = intersectingFeature;
      }

      return found;
    };